IMPLEMENTATION MODULE MakeLibraries;

  (*
   * MAKEMAKE.  Create a MAKEFILE for a MODULA-2 program.
   *
   * Written by Steve Tynor, 30 September 1986.
   *            UUCP  : tynor@gitpyr
   *            USNAIL: 2550 Akers Mill Rd. T-2, Atlanta GA. 30339
   *
   * Permission is granted to distribute, copy and change this program as long
   * as this notice remains...
   *)

  (*
   * Modified by R.A. Dukelow (24 January 1987) for to run under Logitech
   * Modula-2/86. See MakeMake.MOD for additional comments.
   *)

 (* NOTE: this module is implementation specific.   Substitute the library
  *       modules supplied by your compiler.
  *)
IMPORT Strings;

CONST
  NumLibraryModules = 39;

VAR
  i: CARDINAL;
  LibraryModule : ARRAY [1 .. NumLibraryModules] OF
                      ARRAY [0 .. 20] OF CHAR;

  (*-----------------------------------------------------------------------*)
  PROCEDURE IsALibraryModule (modulename : ARRAY OF CHAR) : BOOLEAN;
    (* binary search... *)
  VAR
    low, mid, high : CARDINAL;
  BEGIN
    low := 1;
    high := NumLibraryModules;
    WHILE low <= high DO
      mid := low + (high - low) DIV 2;
      CASE Strings.CompareStr (modulename, LibraryModule[mid]) OF
        0 : RETURN TRUE; (* Strings.Equal *)
      | -1 : high := mid - 1; (* Strings.Less *)
      ELSE
          low := mid + 1;
      END; (* CASE *)
    END; (* WHILE *)
    RETURN FALSE;
  END IsALibraryModule;

BEGIN
   (* NOTE: we're doing a binary search, so these must be in sorted order: *)

   (* Logitech supplied libraries: *)
  i := 1;
  LibraryModule [i] := 'ASCII'; INC(i);
  LibraryModule [i] := 'Break'; INC(i);
  LibraryModule [i] := 'CardinalIO'; INC(i);
  LibraryModule [i] := 'Conversions'; INC(i);
  LibraryModule [i] := 'DOS3'; INC(i); (* ASCII DO... < De... *)
  LibraryModule [i] := 'DOS31'; INC(i);
  LibraryModule [i] := 'Debug'; INC(i);
  LibraryModule [i] := 'Decimals'; INC(i);
  LibraryModule [i] := 'Devices'; INC(i);
  LibraryModule [i] := 'Directories'; INC(i);
  LibraryModule [i] := 'DiskDirectory'; INC(i);
  LibraryModule [i] := 'DiskFiles'; INC(i);
  LibraryModule [i] := 'Display'; INC(i);
  LibraryModule [i] := 'ErrorCode'; INC(i);
  LibraryModule [i] := 'FileMessage'; INC(i);
  LibraryModule [i] := 'FileNames'; INC(i);
  LibraryModule [i] := 'FileSystem'; INC(i);
  LibraryModule [i] := 'InOut'; INC(i);
  LibraryModule [i] := 'Keyboard'; INC(i);
  LibraryModule [i] := 'LogiMouse'; INC(i);
  LibraryModule [i] := 'MathLib0'; INC(i);
  LibraryModule [i] := 'Mouse'; INC(i);
  LibraryModule [i] := 'NumberConversion'; INC(i);
  LibraryModule [i] := 'Options'; INC(i);
  LibraryModule [i] := 'Processes'; INC(i);
  LibraryModule [i] := 'ProgMessage'; INC(i);
  LibraryModule [i] := 'Program'; INC(i);
  LibraryModule [i] := 'RealConversions'; INC(i);
  LibraryModule [i] := 'RealInOut'; INC(i);
  LibraryModule [i] := 'RS232Code'; INC(i);
  LibraryModule [i] := 'RS232Int'; INC(i);
  LibraryModule [i] := 'RS232Polling'; INC(i);
    (* note : Strings.Compare thinks 'SY' < 'St'. (it just compares ASCII
     *        values...) So this is not exactly alphabetical... just sorted 
     *        as Strings.Compare would...
     *)
  LibraryModule [i] := 'SYSTEM'; INC(i);
  LibraryModule [i] := 'Storage'; INC(i);
  LibraryModule [i] := 'Strings'; INC(i);
  LibraryModule [i] := 'System'; INC(i);
  LibraryModule [i] := 'Termbase'; INC(i);
  LibraryModule [i] := 'Terminal'; INC(i);
  LibraryModule [i] := 'TimeDate'; INC(i);

END MakeLibraries.